

Sets

J  componentes  /N2,H2,NH3/
s  correntes    /1*2/;

Positive Variables

flow(J,s)          vazao
temperature(s)     temperatura
pressure(s)        pressao
kp                 constante
conversion         conversao;

Variable
z                  funo objetivo;

* composio da alimentao: proporo estequiomtrica
flow.fx('N2','1') = 1;
flow.fx('H2','1') = 3;
flow.fx('NH3','1') = 0;
*  limites operacionais de temperatura e presso
temperature.LO('2') = 450;
temperature.UP('2') = 1000;
pressure.LO('2') = 1;
pressure.UP('2') = 1000;
pressure.L('2') = 1000;

Equations kp1, kp2, mb1, mb2, temp, press, obj;

* dependncia da constante de equilbrio com a temperatura
kp1..   kp =e= 10**(2250.322/(temperature('2')) - 0.8543 -
               1.51049*log10(temperature('2')) -
               2.58987*10**(-4)*(temperature('2')) +
               1.48961*10**(-7)*(temperature('2'))**2);

* equilbrio da reao: constante de eq x presso do sistema
kp2..   kp*pressure('2')*(flow('N2','2'))**0.5
          *(flow('H2','2'))**1.5 - (flow('NH3','2')
          + flow('H2','2') + flow('N2','2'))
          *flow('NH3','2') =e= 0;

* balanos de massa
mb1..   2*flow('N2','2')+flow('NH3','2')
        =e= 2*flow('N2','1');
mb2..   2*flow('H2','2')+3*flow('NH3','2')
        =e= 2*flow('H2','1');

*  balano de temperatura e presso
temp..   temperature('2') =e= temperature('1');
press..  pressure('2')    =e= pressure('1');

*  funo objetivo: produo de amnia -
*  - custo do ajuste de presso e temperatura
obj..    z =e= flow('NH3','2') - 0.005*pressure('2')
               - 0.001*temperature('2');

Model ammoniareact/ALL/;

option NLP = conopt;
Solve ammoniareact Using NLP Maximizing z;

*option NLP = ipopt;
*Solve ammoniareact Using NLP Maximizing z;

*option NLP = minos;
*Solve ammoniareact Using NLP Maximizing z;

*option NLP = snopt;
*Solve ammoniareact Using NLP Maximizing z;
