
Sets
i   matrias-primas   / oleo1 , oleo2 /
j   produtos          / gasolina , querosene ,
                        combustivel , residual /;

Parameters

cm(i)  custo das materias-primas [$ por barril]
  /    oleo1      24
       oleo2      15  /

cp(j)  custo dos produtos [$ por barril]
  /    gasolina     36
       querosene    24
       combustivel  21
       residual     10    /

cpr(i) custo de processamento [$ por barril]
   /    oleo1      0.5
        oleo2      1.0  /;

Table x(i,j)  rendimento volumtrico

        gasolina  querosene  combustivel  residual
oleo1      0.8      0.05        0.10        0.05
oleo2      0.44     0.10        0.36        0.10;

Variables

r(i) vetor de vazoes de reagentes
p(j) vetor de vazoes de produtos

ct   custo total
rt   renda total
s    saldo (a ser maximizado);

*limites das variaveis
p.up('gasolina')      =  24000 ;
p.up('querosene')     =  2000  ;
p.up('combustivel')   =  6000  ;

Equations

custo       gastos com materias-primas e operacao
produtos(j) vazoes dos produtos =e= reagentes*rendimento
renda       renda atraves da venda dos produtos
saldo       funo objetivo: renda - gastos;

custo       ..   ct    =e=  sum(i, cm(i)*r(i) + cpr(i)*r(i) );
produtos(j) ..   p(j)  =e=  sum(i, x(i,j)*r(i) ) ;
renda       ..   rt    =e=  sum(j, cp(j)*p(j) ) ;
saldo       ..   s     =e=  rt - ct ;

Model refinaria /all/ ;

option LP = cplex;
Solve refinaria using lp maximizing s ;

Display r.l, p.l, s.l ;

