

Sets
J      componentes  /A,B,C/
S      correntes    /1*16/
react  reatores     /I,II,III/
sep    separadores  /col,flash/

Scalars
conver1   conversao do reator I   /0.5/
conver2   conversao do reator II  /0.65/
conver3   conversao do reator III /0.9/

sep_col   grau de separacao da coluna /0.99/
sep_flash grau de separacao do flahs  /0.8/

priceC    preco do produto /75000/;

Positive Variables
flow(J,S), costI, costII,
costIII, costcol, costflash;

Binary Variables
y1, y2, y3, y4, y5;

Variable
z;

Equations
mix_1,
mix2_1,

spl1_1, spl1_2, spl1_3, spl1_4, spl1_5,
spl2_1, spl2_2, spl2_3, spl2_4,

react1_1, react1_2, react1_3, react1_4,
react2_1, react2_2, react2_3, react2_4,
react3_1, react3_2, react3_3, react3_4,

col_1, col_2, col_3, col_4, col_5,

flash_1, flash_2, flash_3, flash_4, flash_5,

obj;

* define a vazo e composio
* das alimentaes
flow.fx('A','1')=1;
flow.fx('B','1')=0;
flow.fx('C','1')=0;
flow.fx('A','2')=0;
flow.fx('B','2')=1;
flow.fx('C','2')=0;

* balanco de massa no 1o misturador
mix_1(J)..   flow(J,'3') =e=
             flow(J,'1')+flow(J,'2');

* balanco de massa no 1o splitter
* restries big M: vazo < vazao_max*y1
spl1_1(J)..  flow(J,'4')=l=1*(y1);
spl1_2(J)..  flow(J,'5')=l=1*(y2);
spl1_3(J)..  flow(J,'6')=l=1*(y3);
spl1_4(J)..  flow(J,'3') =e=
             flow(J,'4')+ flow(J,'5')+ flow(J,'6');
* restrio para escolha de somente 1 reator
spl1_5..     y1+y2+y3=e=1;

* reator I: custo de operao e balanco
* dos componentes usando a conversao
react1_1..   costI =e= 5000*(flow('C','7')+1e-9)**0.6;
react1_2..   flow('C','7')=e=flow('A','4')*conver1 ;
react1_3..   flow('A','7')=e=flow('A','4')*(1-conver1) ;
react1_4..   flow('B','7')=e=flow('B','4')*(1-conver1) ;

* mesma coisa para o reator II
react2_1..   costII =e= 5000*(flow('C','8')+1e-9)**0.7;
react2_2..   flow('C','8')=e=flow('A','5')*conver2 ;
react2_3..   flow('A','8')=e=flow('A','5')*(1-conver2) ;
react2_4..   flow('B','8')=e=flow('B','5')*(1-conver2) ;

* mesma coisa para o reator III
react3_1..   costIII =e= 10000*(flow('C','9')+1e-9)**0.7;
react3_2..   flow('C','9')=e=flow('A','6')*conver3 ;
react3_3..   flow('A','9')=e=flow('A','6')*(1-conver3) ;
react3_4..   flow('B','9')=e=flow('B','6')*(1-conver3) ;

* balanco de massa no 2o misturador
mix2_1(J)..  flow(J,'7')+flow(J,'8')+
             flow(J,'9') =e= flow(J,'10');

* balanco de massa no 2o splitter
spl2_1(J)..  flow(J,'11') =l= 1*(y4);
spl2_2(J)..  flow(J,'12') =l= 1*(y5);
spl2_3(J)..  flow(J,'12')+flow(J,'11')=e=flow(J,'10');
*restricao para escolher somente 1 separador
spl2_4..     y4+y5=e=1;

* restries para coluna de dest.
col_1..      flow('C','14')=e= sep_col*flow('C','11');
flow.fx('A','14')=0;
flow.fx('B','14')=0;
col_2..      flow('A','13')=e=flow('A','11');
col_3..      flow('B','13')=e=flow('B','11');
col_4..      flow('C','13')=e=(1-sep_col)*flow('C','11');
col_5..      costcol =e=10000*y4+flow('C','14')*2000;

* restries do separador bifsico
flash_1..    flow('C','16')=e= sep_flash*flow('C','12');
flow.fx('A','16')=0;
flow.fx('B','16')=0;
flash_2..    flow('A','15')=e=flow('A','12');
flash_3..    flow('B','15')=e=flow('B','12');
flash_4..    flow('C','15')=e=(1-sep_flash)*flow('C','12');
flash_5..    costflash =e= 2000*y5+flow('C','16')*1000;

* funo objetivo: custo simplificado =
* renda com o produto - custo de operao
obj..        z =e= flow('C','14')*priceC +
                   flow('C','16')*priceC -
                   costcol - costflash - costI -
                   costII - costIII;

Model flowsheet /ALL/;

option MINLP = dicopt;
Solve flowsheet using MINLP  maximizing z;

*option MINLP = sbb;
*Solve flowsheet using MINLP  maximizing Z;